
#include <OneWire.h>
#include "TM1637.h"
#include <ESP8266WiFi.h>
#include <WiFiClient.h>
#include <ESP8266WebServer.h>
#include <ESP8266mDNS.h>

ESP8266WebServer server(80);

#define CLK 12 
#define DIO 14 
TM1637 tm1637(CLK, DIO);
int8_t TemperDisp[] = {0x00,0x00,0x00,0x00};
OneWire ds(0);
float temper=0;
float kalibr=0;
String datawifi;
unsigned long pauza;
char *ssid="DSL-2750U";
char *pass="12345678";
byte j=0;

void handleRoot() {
datawifi ="<html><head>";
datawifi +="<meta http-equiv='refresh' content='3'>";
datawifi +="</head><body>";
datawifi += "<h1 style='font:100px Arial; border:1px solid #000;width:200px;'>"+floattostring (temper, 1)+"</h1>";
if (temper>=78) {
datawifi +="<script type='text/javascript'>";
datawifi +="var context = new AudioContext();";
datawifi +="var oscillator = context.createOscillator();";
datawifi +="oscillator.type = 'square';";
datawifi +="oscillator.frequency.value = 800;";
datawifi +="oscillator.connect(context.destination);";
datawifi +="oscillator.start();";
datawifi +="</script>";
}
datawifi +="</body></html>";
server.send(200, "text/html", datawifi);
}

void setup(){
  Serial.begin(9600);
  
  WiFi.begin(ssid, pass);
  while (WiFi.status() != WL_CONNECTED && j<200) {
  j++;
  delay(10);
  }
  
  server.on("/", handleRoot);
  MDNS.begin("esp8266");
  tm1637.init(); //D4056A
  tm1637.set(7);
  server.begin();
}

void loop(){
server.handleClient();
if (millis () >= (pauza + 1000)){ 
tz();

int intemper=okrugl(abs(temper));
    
if (temper<0) TemperDisp[0]= 16;
else TemperDisp[0]= 0x7f;

if (intemper<10){
    TemperDisp[1]= 0x7f;
    TemperDisp[2]= 0x7f;
    TemperDisp[3]= intemper;
}
else if (intemper<100){
    TemperDisp[1]= 0x7f;
    TemperDisp[2]= int(intemper / 10);
    TemperDisp[3]= int(intemper-TemperDisp[2]*10);  
}
else if (temper<1000){
    TemperDisp[1]= int(intemper / 100);
    TemperDisp[2]= int((intemper - TemperDisp[1]*100)/10);
    TemperDisp[3]= int(intemper- TemperDisp[1]*100-TemperDisp[2]*10) ;  
}


tm1637.display(TemperDisp);
pauza = millis ();
}
}



void tz() {
  byte addr[8];
  if ( !ds.search(addr)) {
    ds.reset_search(); 
    return; 
  }
  if (OneWire::crc8(addr, 7) != addr[7]) {
    return;
  }
  byte i;
  byte present = 0;
  byte type_s;
  byte data[12];

  switch (addr[0]) {
  case 0x10:
    type_s = 1;
    break;
  case 0x28:
    type_s = 0;
    break;
  case 0x22:
    type_s = 0;
    break;
  default:
    return;
  } 

  ds.reset();
  ds.select(addr);
  ds.write(0x44, 1);        

  present = ds.reset();
  ds.select(addr);    
  ds.write(0xBE);         

  for ( i = 0; i < 9; i++) {          
    data[i] = ds.read();
  }
  int16_t raw = (data[1] << 8) | data[0];
  if (type_s) {
    raw = raw << 3; 
    if (data[7] == 0x10) {

      raw = (raw & 0xFFF0) + 12 - data[6];
    }
  } 
  else {
    byte cfg = (data[4] & 0x60);

    if (cfg == 0x00) raw = raw & ~7;  
    else if (cfg == 0x20) raw = raw & ~3; 
    else if (cfg == 0x40) raw = raw & ~1; 

  }
  temper=((float)raw / 16.0)+kalibr;

}
String floattostring (float a, int b){

int ia=int(a);
int pp=abs(int((a-ia)*pow(10,b)));
return String(ia)+"."+String(pp);
}

int okrugl(float a) {
int b=int(a);
float c=a-b;
if (c>0.5) return b+1;
else return b;
}



